// Package endoflifedate provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.12.4 DO NOT EDIT.
package endoflifedate

import (
	"context"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	openapi_types "github.com/deepmap/oapi-codegen/pkg/types"
)

// Cycle Details of a single release cycle of a given product. There might be some slight variations to this depending on the product.
type Cycle struct {
	// Cycle Release Cycle
	Cycle *Cycle_Cycle `json:"cycle,omitempty"`

	// Discontinued Whether this cycle is now discontinued.
	Discontinued *Cycle_Discontinued `json:"discontinued,omitempty"`

	// Eol End of Life Date for this release cycle
	Eol *Cycle_Eol `json:"eol,omitempty"`

	// Latest Latest release in this cycle
	Latest *string `json:"latest,omitempty"`

	// Link Link to changelog for the latest release, if available
	Link *string `json:"link,omitempty"`

	// Lts Whether this release cycle has long-term-support (LTS). Can be a date instead in YYYY-MM-DD format as well if the release enters LTS status on a given date.
	Lts *Cycle_Lts `json:"lts,omitempty"`

	// ReleaseDate Release Date for the first release in this cycle
	ReleaseDate *openapi_types.Date `json:"releaseDate,omitempty"`

	// Support Whether this release cycle has active support
	Support *Cycle_Support `json:"support,omitempty"`
}

// CycleCycle0 defines model for .
type CycleCycle0 = string

// CycleCycle1 defines model for .
type CycleCycle1 = bool

// Cycle_Cycle Release Cycle
type Cycle_Cycle struct {
	union json.RawMessage
}

// CycleDiscontinued0 defines model for .
type CycleDiscontinued0 = openapi_types.Date

// CycleDiscontinued1 defines model for .
type CycleDiscontinued1 = bool

// Cycle_Discontinued Whether this cycle is now discontinued.
type Cycle_Discontinued struct {
	union json.RawMessage
}

// CycleEol0 defines model for .
type CycleEol0 = string

// CycleEol1 defines model for .
type CycleEol1 = bool

// Cycle_Eol End of Life Date for this release cycle
type Cycle_Eol struct {
	union json.RawMessage
}

// CycleLts0 defines model for .
type CycleLts0 = string

// CycleLts1 defines model for .
type CycleLts1 = bool

// Cycle_Lts Whether this release cycle has long-term-support (LTS). Can be a date instead in YYYY-MM-DD format as well if the release enters LTS status on a given date.
type Cycle_Lts struct {
	union json.RawMessage
}

// CycleSupport0 defines model for .
type CycleSupport0 = openapi_types.Date

// CycleSupport1 defines model for .
type CycleSupport1 = bool

// Cycle_Support Whether this release cycle has active support
type Cycle_Support struct {
	union json.RawMessage
}

// AsCycleCycle0 returns the union data inside the Cycle_Cycle as a CycleCycle0
func (t Cycle_Cycle) AsCycleCycle0() (CycleCycle0, error) {
	var body CycleCycle0
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromCycleCycle0 overwrites any union data inside the Cycle_Cycle as the provided CycleCycle0
func (t *Cycle_Cycle) FromCycleCycle0(v CycleCycle0) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeCycleCycle0 performs a merge with any union data inside the Cycle_Cycle, using the provided CycleCycle0
func (t *Cycle_Cycle) MergeCycleCycle0(v CycleCycle0) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JsonMerge(b, t.union)
	t.union = merged
	return err
}

// AsCycleCycle1 returns the union data inside the Cycle_Cycle as a CycleCycle1
func (t Cycle_Cycle) AsCycleCycle1() (CycleCycle1, error) {
	var body CycleCycle1
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromCycleCycle1 overwrites any union data inside the Cycle_Cycle as the provided CycleCycle1
func (t *Cycle_Cycle) FromCycleCycle1(v CycleCycle1) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeCycleCycle1 performs a merge with any union data inside the Cycle_Cycle, using the provided CycleCycle1
func (t *Cycle_Cycle) MergeCycleCycle1(v CycleCycle1) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JsonMerge(b, t.union)
	t.union = merged
	return err
}

func (t Cycle_Cycle) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Cycle_Cycle) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsCycleDiscontinued0 returns the union data inside the Cycle_Discontinued as a CycleDiscontinued0
func (t Cycle_Discontinued) AsCycleDiscontinued0() (CycleDiscontinued0, error) {
	var body CycleDiscontinued0
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromCycleDiscontinued0 overwrites any union data inside the Cycle_Discontinued as the provided CycleDiscontinued0
func (t *Cycle_Discontinued) FromCycleDiscontinued0(v CycleDiscontinued0) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeCycleDiscontinued0 performs a merge with any union data inside the Cycle_Discontinued, using the provided CycleDiscontinued0
func (t *Cycle_Discontinued) MergeCycleDiscontinued0(v CycleDiscontinued0) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JsonMerge(b, t.union)
	t.union = merged
	return err
}

// AsCycleDiscontinued1 returns the union data inside the Cycle_Discontinued as a CycleDiscontinued1
func (t Cycle_Discontinued) AsCycleDiscontinued1() (CycleDiscontinued1, error) {
	var body CycleDiscontinued1
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromCycleDiscontinued1 overwrites any union data inside the Cycle_Discontinued as the provided CycleDiscontinued1
func (t *Cycle_Discontinued) FromCycleDiscontinued1(v CycleDiscontinued1) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeCycleDiscontinued1 performs a merge with any union data inside the Cycle_Discontinued, using the provided CycleDiscontinued1
func (t *Cycle_Discontinued) MergeCycleDiscontinued1(v CycleDiscontinued1) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JsonMerge(b, t.union)
	t.union = merged
	return err
}

func (t Cycle_Discontinued) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Cycle_Discontinued) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsCycleEol0 returns the union data inside the Cycle_Eol as a CycleEol0
func (t Cycle_Eol) AsCycleEol0() (CycleEol0, error) {
	var body CycleEol0
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromCycleEol0 overwrites any union data inside the Cycle_Eol as the provided CycleEol0
func (t *Cycle_Eol) FromCycleEol0(v CycleEol0) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeCycleEol0 performs a merge with any union data inside the Cycle_Eol, using the provided CycleEol0
func (t *Cycle_Eol) MergeCycleEol0(v CycleEol0) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JsonMerge(b, t.union)
	t.union = merged
	return err
}

// AsCycleEol1 returns the union data inside the Cycle_Eol as a CycleEol1
func (t Cycle_Eol) AsCycleEol1() (CycleEol1, error) {
	var body CycleEol1
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromCycleEol1 overwrites any union data inside the Cycle_Eol as the provided CycleEol1
func (t *Cycle_Eol) FromCycleEol1(v CycleEol1) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeCycleEol1 performs a merge with any union data inside the Cycle_Eol, using the provided CycleEol1
func (t *Cycle_Eol) MergeCycleEol1(v CycleEol1) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JsonMerge(b, t.union)
	t.union = merged
	return err
}

func (t Cycle_Eol) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Cycle_Eol) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsCycleLts0 returns the union data inside the Cycle_Lts as a CycleLts0
func (t Cycle_Lts) AsCycleLts0() (CycleLts0, error) {
	var body CycleLts0
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromCycleLts0 overwrites any union data inside the Cycle_Lts as the provided CycleLts0
func (t *Cycle_Lts) FromCycleLts0(v CycleLts0) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeCycleLts0 performs a merge with any union data inside the Cycle_Lts, using the provided CycleLts0
func (t *Cycle_Lts) MergeCycleLts0(v CycleLts0) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JsonMerge(b, t.union)
	t.union = merged
	return err
}

// AsCycleLts1 returns the union data inside the Cycle_Lts as a CycleLts1
func (t Cycle_Lts) AsCycleLts1() (CycleLts1, error) {
	var body CycleLts1
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromCycleLts1 overwrites any union data inside the Cycle_Lts as the provided CycleLts1
func (t *Cycle_Lts) FromCycleLts1(v CycleLts1) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeCycleLts1 performs a merge with any union data inside the Cycle_Lts, using the provided CycleLts1
func (t *Cycle_Lts) MergeCycleLts1(v CycleLts1) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JsonMerge(b, t.union)
	t.union = merged
	return err
}

func (t Cycle_Lts) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Cycle_Lts) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsCycleSupport0 returns the union data inside the Cycle_Support as a CycleSupport0
func (t Cycle_Support) AsCycleSupport0() (CycleSupport0, error) {
	var body CycleSupport0
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromCycleSupport0 overwrites any union data inside the Cycle_Support as the provided CycleSupport0
func (t *Cycle_Support) FromCycleSupport0(v CycleSupport0) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeCycleSupport0 performs a merge with any union data inside the Cycle_Support, using the provided CycleSupport0
func (t *Cycle_Support) MergeCycleSupport0(v CycleSupport0) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JsonMerge(b, t.union)
	t.union = merged
	return err
}

// AsCycleSupport1 returns the union data inside the Cycle_Support as a CycleSupport1
func (t Cycle_Support) AsCycleSupport1() (CycleSupport1, error) {
	var body CycleSupport1
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromCycleSupport1 overwrites any union data inside the Cycle_Support as the provided CycleSupport1
func (t *Cycle_Support) FromCycleSupport1(v CycleSupport1) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeCycleSupport1 performs a merge with any union data inside the Cycle_Support, using the provided CycleSupport1
func (t *Cycle_Support) MergeCycleSupport1(v CycleSupport1) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JsonMerge(b, t.union)
	t.union = merged
	return err
}

func (t Cycle_Support) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Cycle_Support) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// GetApiAllJson request
	GetApiAllJson(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetApiProductJson request
	GetApiProductJson(ctx context.Context, product string, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetApiProductCycleJson request
	GetApiProductCycleJson(ctx context.Context, product string, cycle string, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) GetApiAllJson(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetApiAllJsonRequest(c.Server)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetApiProductJson(ctx context.Context, product string, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetApiProductJsonRequest(c.Server, product)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetApiProductCycleJson(ctx context.Context, product string, cycle string, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetApiProductCycleJsonRequest(c.Server, product, cycle)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewGetApiAllJsonRequest generates requests for GetApiAllJson
func NewGetApiAllJsonRequest(server string) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/api/all.json")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewGetApiProductJsonRequest generates requests for GetApiProductJson
func NewGetApiProductJsonRequest(server string, product string) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "product", runtime.ParamLocationPath, product)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/api/%s.json", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewGetApiProductCycleJsonRequest generates requests for GetApiProductCycleJson
func NewGetApiProductCycleJsonRequest(server string, product string, cycle string) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "product", runtime.ParamLocationPath, product)
	if err != nil {
		return nil, err
	}

	var pathParam1 string

	pathParam1, err = runtime.StyleParamWithLocation("simple", false, "cycle", runtime.ParamLocationPath, cycle)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/api/%s/%s.json", pathParam0, pathParam1)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// GetApiAllJson request
	GetApiAllJsonWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetApiAllJsonResponse, error)

	// GetApiProductJson request
	GetApiProductJsonWithResponse(ctx context.Context, product string, reqEditors ...RequestEditorFn) (*GetApiProductJsonResponse, error)

	// GetApiProductCycleJson request
	GetApiProductCycleJsonWithResponse(ctx context.Context, product string, cycle string, reqEditors ...RequestEditorFn) (*GetApiProductCycleJsonResponse, error)
}

type GetApiAllJsonResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *[]string
}

// Status returns HTTPResponse.Status
func (r GetApiAllJsonResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetApiAllJsonResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetApiProductJsonResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *[]Cycle
}

// Status returns HTTPResponse.Status
func (r GetApiProductJsonResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetApiProductJsonResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetApiProductCycleJsonResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *Cycle
}

// Status returns HTTPResponse.Status
func (r GetApiProductCycleJsonResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetApiProductCycleJsonResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// GetApiAllJsonWithResponse request returning *GetApiAllJsonResponse
func (c *ClientWithResponses) GetApiAllJsonWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetApiAllJsonResponse, error) {
	rsp, err := c.GetApiAllJson(ctx, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetApiAllJsonResponse(rsp)
}

// GetApiProductJsonWithResponse request returning *GetApiProductJsonResponse
func (c *ClientWithResponses) GetApiProductJsonWithResponse(ctx context.Context, product string, reqEditors ...RequestEditorFn) (*GetApiProductJsonResponse, error) {
	rsp, err := c.GetApiProductJson(ctx, product, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetApiProductJsonResponse(rsp)
}

// GetApiProductCycleJsonWithResponse request returning *GetApiProductCycleJsonResponse
func (c *ClientWithResponses) GetApiProductCycleJsonWithResponse(ctx context.Context, product string, cycle string, reqEditors ...RequestEditorFn) (*GetApiProductCycleJsonResponse, error) {
	rsp, err := c.GetApiProductCycleJson(ctx, product, cycle, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetApiProductCycleJsonResponse(rsp)
}

// ParseGetApiAllJsonResponse parses an HTTP response from a GetApiAllJsonWithResponse call
func ParseGetApiAllJsonResponse(rsp *http.Response) (*GetApiAllJsonResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetApiAllJsonResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest []string
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	}

	return response, nil
}

// ParseGetApiProductJsonResponse parses an HTTP response from a GetApiProductJsonWithResponse call
func ParseGetApiProductJsonResponse(rsp *http.Response) (*GetApiProductJsonResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetApiProductJsonResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest []Cycle
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	}

	return response, nil
}

// ParseGetApiProductCycleJsonResponse parses an HTTP response from a GetApiProductCycleJsonWithResponse call
func ParseGetApiProductCycleJsonResponse(rsp *http.Response) (*GetApiProductCycleJsonResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetApiProductCycleJsonResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest Cycle
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	}

	return response, nil
}
